#include <bits/stdc++.h>

using namespace std;

int niz[200010];

int main()
{
    ios::sync_with_stdio(false);
	cin.tie(0);

	int n,c,q;
	cin>>n>>c>>q;
	string s;
	cin>>s;
	int zbir=0;
	for(int i=0;i<n;i++)
    {
        niz[i]=s[i]-'0';
        zbir+=niz[i];
    }
    int l,r;
    for(int i=0;i<q;i++)
	{
	    cin>>l>>r;
	    for(int i=l-1;i<=r-1;i++)
        {
            zbir-=niz[i];
            niz[i]=(niz[i]+1)%2;
            zbir+=niz[i];
        }
        cout<<zbir<<endl;
	}
}